/*
   Indesign Calendar Wizard
   
   version 0.8

   by Scott Selberg
   April 3, 2006

*/
var calendarDatesRegExp = new RegExp( "calendarDates(.*)" )
var calendarRegExp = new RegExp( "calendar(Dates|Holidays|Text)(.*)" )
//var knownCalendars = findCalendars();
var knownCalendars = findCalendars().sort();
knownCalendars.unshift("All");
var knownLayers = new Array( "Calendar", "Holidays", "Text" ); 
var alignCalendars = new Array();
var masterLayer;

var knownCalendarIndex = 0;
/********************************************************************/
// Try to find selected text frame
/********************************************************************/
try
{ 
   var selectionObjectType = app.selection[0].toString();
   if( selectionObjectType == "[object TextFrame]" )
   {
      myLabel = app.selection[0].label; 
   }
   else if( selectionObjectType == "[object InsertionPoint]" )
   {
      if( bCS )
      {
         try{ myLabel = app.selection[0].parentTextFrame.label; }
         catch( myError )
         {
            myLabel = app.selection[0].parentTextFrame[0].label;
         }
      }
      else
      {
         myLabel = app.selection[0].parentTextFrames[0].label;
      }
      
   }

   try
   {
      var buffer = calendarRegExp.exec( myLabel );
      for( var i = 0; i < knownCalendars.length; i++ )
      {
         if( buffer[2] == knownCalendars[i] )
         {
            knownCalendarIndex = i;
         }
      }
   }
   catch( myError ){}
}
catch( myError ){}

/********************************************************************/
// User Interface
/********************************************************************/
var myDialog = app.dialogs.add({name:"Adobe InDesign Calendar Wizard:",canCancel:true});
with(myDialog)
{
   //Add a dialog column.
   with( dialogColumns.add() )
   {
      with( dialogRows.add() )
      {
         staticTexts.add({staticLabel:"Select Calendar"});
         var selectCalendar = dropdowns.add({stringList:knownCalendars,
                                             selectedIndex:knownCalendarIndex});
      }
      with( dialogRows.add() )
      {
         staticTexts.add({staticLabel:"Align calender to layer"});
         var selectMasterLayer = dropdowns.add({stringList:knownLayers,
                                                selectedIndex:0});
      }
   }
}

var myResult = myDialog.show();
if(myResult == true)
{
   if( knownCalendars[ selectCalendar.selectedIndex ] == "All" )
   {
      alignCalendars = knownCalendars;
      alignCalendars.shift();
   }
   else
   {
      alignCalendars[0] = knownCalendars[ selectCalendar.selectedIndex ];
   }

   if( knownLayers[ selectMasterLayer.selectedIndex ] == "Text" )
   {
      masterLabelPrefix = "calendarText";
   }
   else if( knownLayers[ selectMasterLayer.selectedIndex ] == "Holidays" )
   {
      masterLabelPrefix = "calendarHolidays"
   }
   else
   {
      masterLabelPrefix = "calendarDates";
   }

   for( var i = 0; i < alignCalendars.length; i++ )
   {
      alignCalendar( alignCalendars[i], masterLabelPrefix )
   }
}
else
{
   myDialog.destroy();
}


function findCalendars()
{
   var myDocument;
   var myTextFrames;
   var i;
   var knownCalendars = new Array();
   var buffer;
   var myError;

   try
   {
      myDocument = app.activeDocument;
      myTextFrames = myDocument.textFrames;
      for( i = 0; i < myTextFrames.length; i++ )
      {
         buffer = calendarDatesRegExp.exec( myTextFrames.item(i).label );
         try{ knownCalendars.push( buffer[1] ) }
         catch( myError ){ }
      }
   }
   catch( myError )
   {}

   return( knownCalendars )
}

function alignCalendar( calendarIndex, masterLabelPrefix )
{
   var calendarDate     = "calendarDates"    + calendarIndex;
   var calendarHolidays = "calendarHolidays" + calendarIndex;
   var calendarText     = "calendarText"     + calendarIndex;

   if( masterLabelPrefix == "calendarText" )
   {
      slave1Label = calendarDate;
      slave2Label = calendarHolidays;
      masterLabel = calendarText;
   }
   else if( masterLabelPrefix == "calendarHolidays" )
   {
      slave1Label = calendarDate;
      masterLabel = calendarHolidays;
      slave2Label = calendarText;
   }
   else
   {
      masterLabel = calendarDate;
      slave1Label = calendarHolidays;
      slave2Label = calendarText;
   }

   // layer might not exist...
   try{ alignTables( masterLabel, slave1Label ); }
   catch( myError ){}
   
   // layer might not exist...
   try{ alignTables( masterLabel, slave2Label ); }
   catch( myError ){}

   return;
}

function alignTables( label1, label2 )
{
   var myDocument = app.activeDocument;
   var frame1 = myDocument.textFrames.item( label1 );
   var frame2 = myDocument.textFrames.item( label2 );

   var table1 = frame1.tables.firstItem();
   var table2 = frame2.tables.firstItem();

   var myMasterRow = table1.rows.lastItem().cells;
   var mySlaveRow  = table2.rows.lastItem().cells;

   for( var i = 0; i < myMasterRow.length; i++ )
   {
      mySlaveRow[i].width = myMasterRow[i].width;
   }

   var myMasterColumn = table1.columns.firstItem().cells;
   var mySlaveColumn  = table2.columns.firstItem().cells;

   for( var i = 0; i < myMasterColumn.length; i++ )
   {
      mySlaveColumn[i].height = myMasterColumn[i].height;
   }

   return;
}
